<?php
/**
 * New Books Extended module for BookLibrary
 * @version 1.5
 * mod_booklibrary_newbooks_ext
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * rewriting for Joomla 1.5 by Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru), March 2009;
*/

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Restricted access' );
$database = &JFactory::getDBO();

if( !function_exists( 'sefreltoabs')) {
  function sefRelToAbs( $value ) {
    //Need check!!!

    // Replace all &amp; with & as the router doesn't understand &amp;
    $url = str_replace('&amp;', '&', $value);
    if(substr(strtolower($url),0,9) != "index.php") return $url;
    $uri    = JURI::getInstance();
    $prefix = $uri->toString(array('scheme', 'host', 'port'));
    return $prefix.JRoute::_($url);
  }
}


//Define Main parameters
$moduleclass_sfx = $params->get('moduleclass_sfx', '');

$sortnewby = $params->def('sortnewby', 1);
$show_published = $params->def('only_published', 1);
$displaytype = $params->def('displaytype', 0);

switch($sortnewby) {
case 0:
    $sql_orderby_query = "b.date";    // Last Edited
    break;
case 1:
    $sql_orderby_query    = "b.id";        // Last Added
    break;
}
//Check if only display published items
if ($show_published==1) {
    $sql_published = "AND b.published=1 ";
} else {
    $sql_published = "";
}

//Define Book parameters
$count_book = intval($params->def('count_book',1));
$words_book = $params->def('words_book','');
$showtitle_book = $params->def('showtitle_book', 1);
$showauthor_book = $params->def('showauthor_book', 1);
$showcover_book	= $params->def('showcover_book', 1);
$coversize_book	= $params->def('coversize_book', '127');

//Define Game parameters
$count_game = intval($params->def('count_game',1));
$words_game = $params->def('words_game','');
$showtitle_game = $params->def('showtitle_game', 1);
$showauthor_game = $params->def('showauthor_game', 1);
$showcover_game = $params->def('showcover_game', 1);
$coversize_game = $params->def('coversize_game', '127');

//Define Music parameters
$count_music = intval($params->def('count_music',1));
$words_music = $params->def('words_music','');
$showtitle_music = $params->def('showtitle_music', 1);
$showauthor_music = $params->def('showauthor_music', 1);
$showcover_music = $params->def('showcover_music', 1);
$coversize_music = $params->def('coversize_music', '127');

//Define Video parameters
$count_video = intval($params->def('count_video',1));
$words_video = $params->def('words_video','');
$showtitle_video = $params->def('showtitle_video', 1);
$showauthor_video = $params->def('showauthor_video', 1);
$showactor_video = $params->def('showactor_video', 1);
$showcover_video = $params->def('showcover_video', 1);
$coversize_video = $params->def('coversize_video', '127');


    $selectstring = "SELECT id FROM #__menu WHERE link='index.php?option=com_medialibrary'";
    $database->setQuery($selectstring);
    $ItemId_tmp = $database->loadResult();

//////////////////////////////////////////////
if($count_book!='' && $count_book!=0) {
    $selectstring = "SELECT a.title, a.authors, a.imageURL, a.comment,  b.id, b.date, b.media_type, b.catid   FROM #__medialibrary_book AS a, #__medialibrary AS b ". 
                    "WHERE b.media_type='book' AND b.media_id=a.id ".$sql_published.
                    "\nORDER BY ".$sql_orderby_query." DESC LIMIT 0,$count_book;";
    $database->setQuery($selectstring);
    $rows_books = $database->loadObjectList();
}

if($count_game!='' && $count_game!=0) {
    $selectstring = "SELECT a.title, a.studio, a.imageURL, a.comment,  b.id, b.date, b.media_type, b.catid FROM #__medialibrary_game AS a, #__medialibrary AS b ". 
                    "WHERE b.media_type='game' AND b.media_id=a.id ".$sql_published.
                    "\nORDER BY ".$sql_orderby_query." DESC LIMIT 0,$count_game;";
    $database->setQuery($selectstring);
    $rows_games = $database->loadObjectList();
}

if($count_music!='' && $count_music!=0) {
    $selectstring = "SELECT a.title, a.artist, a.imageURL, a.comment,  b.id, b.date, b.media_type, b.catid FROM #__medialibrary_music AS a, #__medialibrary AS b ". 
                    "WHERE b.media_type='music' AND b.media_id=a.id ".$sql_published.
                    "\nORDER BY ".$sql_orderby_query." DESC LIMIT 0,$count_music;";
    $database->setQuery($selectstring);
    $rows_musics = $database->loadObjectList();
}

if($count_video!='' && $count_video!=0) {
    $selectstring = "SELECT a.title, a.studio, a.actors, a.imageURL, a.comment,  b.id, b.date, b.media_type, b.catid FROM #__medialibrary_video AS a, #__medialibrary AS b ". 
                    "WHERE b.media_type='video' AND b.media_id=a.id ".$sql_published.
                    "\nORDER BY ".$sql_orderby_query." DESC LIMIT 0,$count_video;";
    $database->setQuery($selectstring);
    $rows_videos = $database->loadObjectList();
}


/////////////////DISPLAY SECTION

function displayHorizontal($rows, $name, $g_words, $showtitle, $showauthor, $showcover, $coversize, $showactor_video='')
{
    echo "<table cellpadding='1' cellspacing='1' class='moduletable' width='100%'>";
    echo "<tr>";
    echo "<td><strong><font size='4'>$name  </font></strong></td>";
    
    $database = &JFactory::getDBO();
    $selectstring = "SELECT id FROM #__menu WHERE link='index.php?option=com_medialibrary'";
    $database->setQuery($selectstring);
    $ItemId_tmp = $database->loadResult();
   
    foreach ($rows as $row) { 
        
        $comment = $row->comment;
        $prevwords = count(explode(" ",$comment));
        if(trim($g_words == "" )) $words = $prevwords;
         else $words = intval($g_words);
        $text = implode(" ", array_slice(explode(" ",$comment), 0, $words));
        if (count(explode(" ",$text))<$prevwords){
        $text .= "";
       }
                                    
        $link1 = "index.php?option=com_medialibrary&amp;task=view&amp;catid=".$row->catid."&amp;id=".$row->id."&amp;Itemid=".$ItemId_tmp;

        //for local images
        $imageURL = $row->imageURL;
        if($imageURL != '' && substr($imageURL,0,4) != "http")
        {
            $imageURL = JURI::base() . $row->imageURL;;
        }
        if($imageURL == ''){
            $imageURL = "./components/com_medialibrary/images/no-img_eng.gif";
        }
   /////////////////////////////////////////     
        if($showcover==1) { 
  ?>
        <td>
            <a href="<?php echo sefRelToAbs( $link1 ); ?>" target="_self">
            <img src="<?php echo $imageURL; ?>"  hspace="15" vspace="2" border="0" height="<?php echo $coversize; ?>" />
            </a>
        </td>
 <?php 
        } //End Show Image If 
        
        if ($showtitle == "1") {
 ?>
        <td valign="top">
        <p><strong><?php echo $row->title;?></strong><br/>
        <?php } 

       if ($showauthor == "1") { 
           echo "By&nbsp;";
           if($row->media_type=='book') echo $row->authors;
              else if($row->media_type=='game') echo $row->studio;
                 else if($row->media_type=='music') echo $row->artist;
                    else echo $row->studio;
                                } 
        
        if ($row->media_type=='video' && $showactor_video == "1")
                         echo "<br /><b>Actors</b>: ".$row->actors;
        ?>
               
                <p><?php echo $text; ?></p>
                <p><a class="readon" href="<?php echo sefRelToAbs( $link1 ); ?>" target="_self"><i>Read Reviews...</i></a></p>
        </td>
        <td>&nbsp;&nbsp;</td> 
 <?php               
   }  //end for each rows
   echo "</tr>";           
   echo "</table>";
} //end function

    
function displayVertical($rows, $name, $g_words, $showtitle, $showauthor, $showcover, $coversize, $showactor_video='')
{
    echo "<table cellpadding='1' cellspacing='1' class='moduletable' width='100%'>";
    echo "<tr><td><strong><font size='4'>$name  </font></strong></td></tr>";
   
    $database = &JFactory::getDBO();
    $selectstring = "SELECT id FROM #__menu WHERE link='index.php?option=com_medialibrary'";
    $database->setQuery($selectstring);
    $ItemId_tmp = $database->loadResult();
   
    foreach ($rows as $row) { 
        
        $comment = $row->comment;
        $prevwords = count(explode(" ",$comment));
        if(trim($g_words == "" )) $words = $prevwords;
         else $words = intval($g_words);
        $text = implode(" ", array_slice(explode(" ",$comment), 0, $words));
        if (count(explode(" ",$text))<$prevwords){
        $text .= "";
       }
                                    
        $link1 = "index.php?option=com_medialibrary&amp;task=view&amp;catid=".$row->catid."&amp;id=".$row->id."&amp;Itemid=".$ItemId_tmp;

        //for local images
        $imageURL = $row->imageURL;
        if($imageURL != '' && substr($imageURL,0,4) != "http")
        {
            $imageURL = JURI::base() . $row->imageURL;;
        }
        if($imageURL == ''){
            $imageURL = "./components/com_medialibrary/images/no-img_eng.gif";
        }
   /////////////////////////////////////////     
        if($showcover==1) { 
  ?>
        <tr>
            <td>
            <a href="<?php echo sefRelToAbs( $link1 ); ?>" target="_self">
            <img src="<?php echo $imageURL; ?>"  hspace="15" vspace="2" border="0" height="<?php echo $coversize; ?>" />
            </a>
            </td>
        </tr>
 <?php 
        } //End Show Image If 
          
        if ($showtitle == "1") {
 ?>
        <tr>
        <td>
        <p><strong><?php echo $row->title;?></strong><br/>
        <?php } 

        if ($showauthor == "1") { 
           echo "By&nbsp;";
           if($row->media_type=='book') echo $row->authors;
              else if($row->media_type=='game') echo $row->studio;
                 else if($row->media_type=='music') echo $row->artist;
                    else echo $row->studio;
                                } 
        
        
        if ($showactor_video=="1" && $row->media_type=='video') echo "<br /><b>Actors</b>: ".$row->actors;       
        ?>
               
                <p><?php echo $text; ?></p>
                <p><a class="readon" href="<?php echo sefRelToAbs( $link1 ); ?>" target="_self"><i>Read Reviews...</i></a></p>
        </td>
        </tr>
        <tr><td>&nbsp;&nbsp;</td></tr> 
 <?php               
   }  //end for each rows
   echo "</table>";
} //end function
?>

    
<?php	
 if($displaytype==1) { // Display Horizontal         

  if(count($rows_books)) { 
      displayHorizontal($rows_books, 'New Books ',$words_book, $showtitle_book, $showauthor_book, $showcover_book, $coversize_book); 
  }  	
  if(count($rows_games)) { 
      displayHorizontal($rows_games, 'New Games ',$words_game, $showtitle_game, $showauthor_game, $showcover_game, $coversize_game); 
  }
  if(count($rows_musics)) { 
      displayHorizontal($rows_musics, 'New Music ',$words_music, $showtitle_music, $showauthor_music, $showcover_music, $coversize_music); 
  }
  if(count($rows_videos)) { 
      displayHorizontal($rows_videos, 'New Video ',$words_video, $showtitle_video, $showauthor_video, $showcover_video, $coversize_video, $showactor_video); 
  }
} else {  //Display Vertical
  
  if(count($rows_books)) { 
      displayVertical($rows_books, 'New Books ',$words_book, $showtitle_book, $showauthor_book, $showcover_book, $coversize_book); 
  }      
  if(count($rows_games)) { 
      displayVertical($rows_games, 'New Games ',$words_game, $showtitle_game, $showauthor_game, $showcover_game, $coversize_game); 
  }
  if(count($rows_musics)) { 
      displayVertical($rows_musics, 'New Music ',$words_music, $showtitle_music, $showauthor_music, $showcover_music, $coversize_music); 
  }
  if(count($rows_videos)) { 
      displayVertical($rows_videos, 'New Video ',$words_video, $showtitle_video, $showauthor_video, $showcover_video, $coversize_video, $showactor_video); 
  }  
}  
?>


